	var places = new Array();
	var transitions = new Array();
	var arcs = new Array();

	var dx, dy;
	var posX = 0, posY = 0;

	var tBar, bar;
	
	var play = false;
	var globalTime = 0;
	var minTime = 0;

	var scale = 10;

	function init()
	{
		ellipses = document.getElementsByTagName("ellipse");
		del = new Array();

		for(i =0; i<ellipses.length; i++)
		{
			if(ellipses[i].getAttribute("type") == "place")
			{
				id = ellipses[i].getAttribute("id");
				capacity = ellipses[i].getAttribute("capacity");
				marking = ellipses[i].getAttribute("marking");

				pl = new place(id, capacity, marking);

				ellipses[i].addEventListener("click", pl, false);
				places.push(pl);
			}
			else if(ellipses[i].getAttribute("type") == "dot")
				del.push(ellipses[i]);
		}

		for(i =0; i<del.length; i++)
			document.documentElement.removeChild(del[i]);

		rects = document.getElementsByTagName("rect");
		for(i =0; i<rects.length; i++)
		{
			if(rects[i].getAttribute("type") == "transition")
			{
				id = rects[i].getAttribute("id");
				priority = rects[i].getAttribute("priority");
				time = rects[i].getAttribute("time");

				tr = new transition(id, priority, time);

				rects[i].addEventListener("click", tr, false);
				transitions.push(tr);
			}
		}

		polylines = document.getElementsByTagName("polyline");
		for(i=0; i<polylines.length; i++)
		{
			if(polylines[i].getAttribute("type") == "arc")
			{
				weight = polylines[i].getAttribute("weight");

				placeId = polylines[i].getAttribute("place");
				transitionId = polylines[i].getAttribute("transition");
				target = polylines[i].getAttribute("target");

				place = null;
				for(k=0; k<places.length; k++)
					if(places[k].id == placeId)
					{
						place = places[k];
						break;
					}

				transition = null;
				for(j=0; j<transitions.length; j++)
					if(transitions[j].id == transitionId)
					{
						transition = transitions[j];
						break;
					}

				ar = new arc(weight, place, transition);

				polylines[i].addEventListener("click", ar, false);
				arcs.push(ar);

				if(target == "transition")
				{
					transition.inPlaces.push(new pair(place, weight));
					place.outTransitions.push(transition);
				}
				else
				{
					place.inTransitions.push(transition);
					transition.outPlaces.push(new pair(place, weight));
				}
			}
		}

		texts = document.getElementsByTagName("text");
		del = new Array();
		for(i = 0; i <texts.length; i++)
			if(texts[i].getAttribute("type") == "marking")
				del.push(texts[i]);

		for(i = 0; i <del.length; i++)
			document.documentElement.removeChild(del[i]);			

		updateTransitions();
		updatePlaces();

		tBar = new toolbar();
		bar = tBar.g;
		tBar.bar.addEventListener("mousedown", mousedownListener, false);
	}

	function pair(first, second)
	{
		this.first = first;
		this.second = parseInt(second);

		return this;
	}

	function place(_id, _capacity, _marking)
	{
		this.id = _id;
		this.capacity = parseInt(_capacity);
		this.marking = parseInt(_marking);

		this.inTransitions = new Array();
		this.outTransitions = new Array();
			
		this.handleEvent = function(evt)
		{
			switch (evt.type)
			{
				case "click":
				alert("Marking: "+this.marking +"\n Capacity: " +this.capacity);
				
				break;
			}
		}

    this.dots = new Array();
    this.update = function()
    {
      for(j =0; j<this.dots.length; j++)
      {
        document.documentElement.removeChild(this.dots[j]);
      }
      this.dots = new Array();

      element = document.getElementById(this.id);
      x = parseInt(element.getAttribute("cx"));
      y = parseInt(element.getAttribute("cy"));

      w = parseInt(element.getAttribute("rx"));
      h = parseInt(element.getAttribute("ry"));

      x -= w;
      y -= h;

      w *= 2;
      h *= 2;

      switch(this.marking)
      {
	    case 0:
		  break;

        case 1:
	      this.dots.push(createDot(x +(w -60) /2, y + (h -60) /2)); break;

        case 2:
	      this.dots.push(createDot(x +(w -60) /3, y +(h -60) /2));
	      this.dots.push(createDot(x + 2* (w -60) /3, y +(h -60) /2));
	  
	      break;

        case 3:
		  this.dots.push(createDot(x +(w -60) /2, (y +(h -60) /3) -10));
	      this.dots.push(createDot(x + (w -60) /3, (y + 2* (h -60) /3) +10));
	      this.dots.push(createDot(x + 2* (w -60) /3, (y + 2* (h -60) /3) +10));
	  
	      break;

        case 4:
		  this.dots.push(createDot(x +(w -60) /3, (y +(h -60) /3) -10));
	      this.dots.push(createDot(x + 2* (w -60) /3, (y +(h -60) /3) -10));
	      this.dots.push(createDot(x +(w -60) /3, (y + 2* (h -60) /3) +10));
	      this.dots.push(createDot(x + 2* (w -60) /3, (y + 2* (h -60) /3) +10));
	  
	      break;

	    default:
          this.dots[0] = document.createElementNS("http://www.w3.org/2000/svg", "text");
	      this.dots[0].setAttribute("x", x +w /2 -100);
	      this.dots[0].setAttribute("y", y +h /2 +60);
		  this.dots[0].setAttribute("class", "marking");
          this.dots[0].textContent = this.marking;

	      document.documentElement.appendChild(this.dots[0]);

	    break;
      }
    }

    return this;
  }

	function createDot(x, y)
	{
		dot = document.createElementNS("http://www.w3.org/2000/svg", "ellipse");
		dot.setAttribute("cx", x +30);
		dot.setAttribute("cy", y +30);
		dot.setAttribute("rx", 30);
		dot.setAttribute("ry", 30);

		dot.setAttribute("class", "dot");
		document.documentElement.appendChild(dot);

		return dot;
	}

	function transition(_id, _priority, _time)
	{
		this.id = _id;
		this.priority = parseInt(_priority);
		this.time = parseInt(_time);

		this.active = false;
		this.waiting = false;
		this.currentTime = -1;
		this.activationTime = 0;

		this.inPlaces = new Array();
		this.outPlaces = new Array();

		this.text = null;
		texts = document.getElementsByTagName("text");
		for(k=0; k <texts.length; k++)
			if(texts[k].getAttribute("parent") == this.id)
			{
				this.text = texts[k];
				break;
			}

		this.handleEvent = function(evt)
		{
			switch(evt.type)
			{
				case "click":
					if(this.active && !this.waiting)
					{
						for(i=0; i<this.inPlaces.length; i++)
							this.inPlaces[i].first.marking -= this.inPlaces[i].second;

						for(i=0; i<this.outPlaces.length; i++)
							this.outPlaces[i].first.marking += this.outPlaces[i].second;

						updateTransitions();
						updatePlaces();

						if(this.currentTime == 0)
						{
							//globalTime = 0;
							minTime = globalTime;
							tBar.text.textContent = globalTime;
						}
					}
					else if(this.waiting)
						alert("currentTime: " +this.currentTime +", activation: " +this.activationTime);
					break;
			}
		}

		return this;
	}

  function arc(_weight, _place, _transition)
  {
    this.weight = parseInt(_weight);
    this.place = _place;
    this.transition = _transition;

    this.handleEvent = function(evt)
    {
      switch (evt.type)
      {
        case "click":
          alert(this.weight);
          break;
      }
    }

    return this;
  }

	function updateTransitions()
	{
		for(i = 0; i <transitions.length; i++)
		{
			trans = transitions[i];
			active = true;

			for(j = 0; j <trans.inPlaces.length; j++)
			{
				if(trans.inPlaces[j].first.marking < trans.inPlaces[j].second)
				{
					active = false;
					break;
				}
			}

			for(j = 0; j <trans.outPlaces.length; j++)
			{
				if(trans.outPlaces[j].first.capacity > 0)
				{
					free = trans.outPlaces[j].first.capacity -trans.outPlaces[j].first.marking;
					if(trans.outPlaces[j].second > free)
					{
						active = false;
						break;
					}
				}
			}

			if(trans.text)
			{
				if(active)
				{
					if(trans.active == false)
					{
						trans.active = true;
						trans.activationTime = globalTime;
						trans.currentTime = trans.time;

						if(trans.time > 0)
							trans.waiting = true;
						minTime = globalTime;
					}

					trans.currentTime = trans.time +trans.activationTime -globalTime;
					trans.text.textContent = trans.priority +"|" +trans.currentTime;

					if(globalTime -trans.activationTime >= trans.time)
					{
						trans.waiting = false;
						minTime = globalTime;
					}
				}
				else
				{
					trans.waiting = false
					trans.active = false;

					trans.currentTime = trans.activationTime = 0;
					trans.text.textContent = trans.priority +"|" +trans.time;
				}
			}
			else
				trans.active = active;
/*
			if(trans.active)
			{
				if(trans.waiting)
				{
					trans.currentTime = trans.time +trans.activationTime -globalTime;
					trans.text.textContent = trans.priority +"|" +trans.currentTime;
				}
			}

			if((trans.active == false) && (active == true))
			{
				trans.active = true;
				trans.activationTime = globalTime;
//				trans.currentTime = trans.time;

				if(trans.time > 0)
					trans.waiting = true;

			}
			else if(trans.active && trans.waiting)
			{
				if(active == false)
				{
					trans.active = false;
					trans.waiting = false;

					trans.currentTime = 0;
					trans.text.textContent = trans.priority +"|" +trans.currentTime;
				}
				else
					if(globalTime -trans.activationTime >= trans.time)
						trans.waiting = false;
			}
			else
				trans.active = active;
*/
			if(trans.active)
			{
				if(trans.waiting)
					document.getElementById(trans.id).setAttribute("style", "fill:grey");
				else
					document.getElementById(trans.id).setAttribute("style", "fill:red");
			}
			else
				document.getElementById(trans.id).setAttribute("style", "fill:white");
		}
	}

	function updatePlaces() 
	{ 
		for(i =0; i<places.length; i++)
		{
			places[i].update();
			document.getElementById(places[i].id).setAttribute("style", "fill:white");
		}
	}

	function toolbar()
	{
		this.g = document.createElementNS("http://www.w3.org/2000/svg", "g");

		this.rect = document.createElementNS("http://www.w3.org/2000/svg", "rect");
		this.rect.setAttribute("x", 0);
		this.rect.setAttribute("y", 0);
		this.rect.setAttribute("width", 300);
		this.rect.setAttribute("height", 1020);
		this.rect.setAttribute("fill", "none");
		this.rect.setAttribute("stroke-width", "0.2in");
		this.rect.setAttribute("stroke", "black");
		this.rect.setAttribute("style", "shape-rendering:crispEdges");
		this.g.appendChild(this.rect);

		this.bar = document.createElementNS("http://www.w3.org/2000/svg", "rect");
		this.bar.setAttribute("x", 0);
		this.bar.setAttribute("y", 0);
		this.bar.setAttribute("width", 300);
		this.bar.setAttribute("height", 75);
		this.bar.setAttribute("fill", "black");
		this.bar.setAttribute("stroke-width", "0.2in");
		this.bar.setAttribute("stroke", "black");
		this.bar.setAttribute("style", "shape-rendering:crispEdges");
		this.g.appendChild(this.bar);

		this.play = document.createElementNS("http://www.w3.org/2000/svg", "polygon");
		this.play.transform.baseVal.appendItem(makeTranslate(90, 160));
		this.play.points.appendItem(makePoint(0, 0));
		this.play.points.appendItem(makePoint(0, 160));
		this.play.points.appendItem(makePoint(125, 80));
		this.play.setAttribute("style", "stroke:black;fill:white");
		this.play.addEventListener("click", playstopListener, false);
		this.g.appendChild(this.play);

		this.stop = document.createElementNS("http://www.w3.org/2000/svg", "rect");
		this.stop.transform.baseVal.appendItem(makeTranslate(90, 175));
		this.stop.setAttribute("x", 0);
		this.stop.setAttribute("y", 0);
		this.stop.setAttribute("width", 130);
		this.stop.setAttribute("height", 130);
		this.stop.setAttribute("style", "stroke:black;fill:white;visibility:hidden");

		this.stop.addEventListener("click", playstopListener, false);
		this.g.appendChild(this.stop);

		this.ffrwrd = new Array(2);
		this.ffrwrd[0] = document.createElementNS("http://www.w3.org/2000/svg", "rect");
		this.ffrwrd[0].transform.baseVal.appendItem(makeTranslate(90, 460));
		this.ffrwrd[0].setAttribute("x", 0);
		this.ffrwrd[0].setAttribute("y", 0);
		this.ffrwrd[0].setAttribute("width", 20);
		this.ffrwrd[0].setAttribute("height", 160);
		this.ffrwrd[0].setAttribute("style", "stroke:black;fill:white");
		this.ffrwrd[0].addEventListener("click", forwardListener, false);
		this.g.appendChild(this.ffrwrd[0]);

		this.ffrwrd[1] = document.createElementNS("http://www.w3.org/2000/svg", "polygon");
		this.ffrwrd[1].transform.baseVal.appendItem(makeTranslate(145, 460));
		this.ffrwrd[1].points.appendItem(makePoint(0, 5));
		this.ffrwrd[1].points.appendItem(makePoint(0, 155));
		this.ffrwrd[1].points.appendItem(makePoint(70, 80));
		this.ffrwrd[1].setAttribute("style", "stroke:black;fill:white");
		this.ffrwrd[1].addEventListener("click", forwardListener, false);
		this.g.appendChild(this.ffrwrd[1]);

		this.bck = new Array(2);
		this.bck[0] = document.createElementNS("http://www.w3.org/2000/svg", "rect");
		this.bck[0].transform.baseVal.appendItem(makeTranslate(195, 760));
		this.bck[0].setAttribute("x", 0);
		this.bck[0].setAttribute("y", 0);
		this.bck[0].setAttribute("width", 20);
		this.bck[0].setAttribute("height", 160);
		this.bck[0].setAttribute("style", "stroke:black;fill:white");
		this.bck[0].addEventListener("click", backwardListener, false);
		this.g.appendChild(this.bck[0]);

		this.bck[1] = document.createElementNS("http://www.w3.org/2000/svg", "polygon");
		this.bck[1].transform.baseVal.appendItem(makeTranslate(90, 760));
		this.bck[1].points.appendItem(makePoint(70, 5));
		this.bck[1].points.appendItem(makePoint(70, 155));
		this.bck[1].points.appendItem(makePoint(0, 80));
		this.bck[1].setAttribute("style", "stroke:black;fill:white;fill-opacity:0.10");
		this.bck[1].addEventListener("click", backwardListener, false);
		this.g.appendChild(this.bck[1]);

		this.frame = document.createElementNS("http://www.w3.org/2000/svg", "rect");
		this.frame.transform.baseVal.appendItem(makeTranslate(0, 1060));
		this.frame.setAttribute("x", 0);
		this.frame.setAttribute("y", 0);
		this.frame.setAttribute("width", 300);
		this.frame.setAttribute("height", 160);
		this.frame.setAttribute("style", "stroke:black;fill:none");
		this.frame.addEventListener("click", backwardListener, false);
		this.g.appendChild(this.frame);

		this.text = document.createElementNS("http://www.w3.org/2000/svg", "text");
		this.text.transform.baseVal.appendItem(makeTranslate(50, 1190));
		this.text.setAttribute("class", "text");
		this.text.appendChild(document.createTextNode(globalTime));

		this.g.appendChild(this.text);

		document.documentElement.appendChild(this.g);
		return this;
	}

	function makePoint(x, y)
	{
		point = document.documentElement.createSVGPoint();
		point.x = x;
		point.y = y;

		return point;
	}

	function makeTranslate(x, y)
	{
		transform = document.documentElement.createSVGTransform();
		transform.setTranslate(x, y);

		return transform;
	}

	function makeRotate(deg, x, y)
	{
		transform = document.documentElement.createSVGTransform();
		transform.setRotate(deg, x, y);

		return transform;
	}

	function playstopListener(evt)
	{
		if(play == true)
		{
			tBar.stop.style.visibility = "hidden";
			tBar.play.style.visibility = "visible";

			globalTime = 0;
			play = false;
		}
		else
		{
			tBar.play.style.visibility = "hidden";
			tBar.stop.style.visibility = "visible";

			play = true;
		}

		updateTransitions();
	}

	function forwardListener(evt)
	{
		if(play)
		{
			for(i = 0; i <transitions.length; i++)
			{
				if(transitions[i].active)
					if(transitions[i].currentTime == 0)
						return;
			}

			globalTime += 1;
			tBar.text.textContent = globalTime;

			updateTransitions();
		}
	}

	function backwardListener(evt)
	{
		if(play && (globalTime > 0) && (globalTime > minTime))
		{
			globalTime -= 1;
			tBar.text.textContent = globalTime;

			updateTransitions();
		}
	}

	function mousedownListener(evt)
	{
		evt.preventDefault();

		if(bar.transform.baseVal.numberOfItems > 0)
		{
			mx = bar.transform.baseVal.getItem(0).matrix;

			dx = mx.e -evt.clientX *scale;
			dy = mx.f -evt.clientY *scale;
		}
		else
		{
			dx = -evt.clientX *scale; dy = -evt.clientY *scale;
		}

		document.addEventListener("mousemove", mousemoveListener, true);
		document.addEventListener("mouseup", mouseupListener, true);
	}

	function mouseupListener(evt)
	{
		document.removeEventListener("mousemove", mousemoveListener, true);
		document.removeEventListener("mouseup", mouseupListener, true);
	}

	function mousemoveListener(evt)
	{
		var id = bar.ownerSVGElement.suspendRedraw(1000);
		bar.transform.baseVal.initialize(makeTranslate(evt.clientX *scale +dx, evt.clientY *scale +dy));
		bar.ownerSVGElement.unsuspendRedraw(id);
	}